## Panel.PanelManager

Panel.PanelManager — Manager of Cinnamon panels

## Functions

| disablePanels ()
| enablePanels ()
| setPanelsOpacity ()
| lowerActorBelowPanels ()
| removePanel ()
| addPanel ()
| movePanel ()
| _destroyDummyPanels ()
| getPanelsInMonitor ()
| getPanels ()
| getPanel ()
| updatePanelsVisibility ()
Panel.Panel | _loadPanel ()
| _onPanelsEnabledChanged ()
| addPanelQuery ()
| movePanelQuery ()
| _showDummyPanels ()

## Object Hierarchy

        Object
        ╰── Panel.PanelManager

## Description

`PanelManager` creates panels and startup and provides methods for easier access of panels

## Functions

### disablePanels ()

    disablePanels ();

Disables (hide and lock) all panels

### enablePanels ()

    enablePanels ();

Enables all panels

### setPanelsOpacity ()

    setPanelsOpacity (int   opacity);

Sets the opacity of all panels to `opacity`

#### Parameters

opacity | opacity of panels |

### lowerActorBelowPanels ()

    lowerActorBelowPanels (ClutterActor   actor);

Lowers actor to just under the panel actors

#### Parameters

actor | actor to stack below the panels |

### removePanel ()

    removePanel (int   panelId);

Remove the panel from the list panels-enabled

#### Parameters

panelId | Panel id of the panel to be removed |

### addPanel ()

    addPanel (integer   monitorIndex,
              integer   panelPosition);

Adds a new panel to the specified position

#### Parameters

monitorIndex | monitor to be added to |
panelPosition | where the panel is added |

### movePanel ()

    movePanel (integer   monitorIndex,
               integer   panelPosition);

Moves the panel of id this.moveId to the specified position

#### Parameters

monitorIndex | monitor to be added to |
panelPosition | where the panel is added |

### _destroyDummyPanels ()

    _destroyDummyPanels ();

Destroys all panel dummies

### getPanelsInMonitor ()

    getPanelsInMonitor (integer   monitorIndex);

Retrieves all the panels in the monitor of index `monitorIndex`

#### Parameters

monitorIndex | index of monitor |

#### Returns

an array of panels

### getPanels ()

    getPanels ();

Retrieves all panels

#### Returns

an array of panels

### getPanel ()

    getPanel (integer   monitorIndex,
              integer   panelPosition);

Gets a specific panel in monitor `monitorIndex`

#### Parameters

monitorIndex | index of monitor |
panelPosition | where the panel is added |

#### Returns

the panel required (null if panel not found)

### updatePanelsVisibility ()

    updatePanelsVisibility ();

Prompts every panel to update its visibility (show/hide). This is used by WindowManager after window map/tile/etc animations, and after popup menus close.

### _loadPanel ()

    Panel.Panel
    _loadPanel (integer   ID,
                integer   monitorIndex,
                integer   panelPosition,
                array     drawcorner,
                array     panelList,
                array     metaList);

Loads a panel with the given properties and appends it to `panelList`. `panelList` is usually this.panels but is a different array when used by _onPanelsEnabledChanged.

#### Parameters

ID | panel id |
monitorIndex | index of monitor of panel |
panelPosition | where the panel should be |
drawcorner | whether to draw corners for [left, right] |
panelList | (optional) the list in which the new panel should be appended to (not necessarily this.panels, c.f. _onPanelsEnabledChanged) Default: this.panels |
metaList | (optional) the list in which the new panel metadata should be appended to (not necessarily this.panelsMeta, c.f. _onPanelsEnabledChanged) Default: this.panelsMeta |

#### Returns

Panel created

### _onPanelsEnabledChanged ()

    _onPanelsEnabledChanged ();

This will be called whenever the panels-enabled settings key is changed i.e. when panels are added, moved or removed.

### addPanelQuery ()

    addPanelQuery ();

Prompts user where to add the panel

### movePanelQuery ()

    movePanelQuery (integer   id);

Prompts user where to move the panel

#### Parameters

id | the id of the panel to be moved |

### _showDummyPanels ()

    _showDummyPanels (callback);

shows the dummy panels

#### Parameters

callback | callback |